version: "3"
services:
  spark-master:
    image: bitnami/spark:latest
    container_name: spark-master
    environment:
      - SPARK_MODE=master
    ports:
      - "7077:7077"
      - "8080:8080"
    volumes:
      - ./data/:/opt/bitnami/spark/work

  spark-worker:
    image: bitnami/spark:latest
    container_name: spark-worker
    environment:
      - SPARK_MODE=worker
      - SPARK_MASTER_URL=spark://spark-master:7077
    depends_on:
      - spark-master
    volumes:
      - ./data/:/opt/bitnami/spark/

  spark-py:
    build:
      context: .
      dockerfile: Dockerfile
    depends_on:
      - spark-master

  # jupyter:
  #   image: jupyter/pyspark-notebook:latest
  #   container_name: pyspark-jupyter
  #   ports:
  #     - "8888:8888"
  #   environment:
  #     - SPARK_OPTS=--master=spark://spark-master:7077
  #     - JUPYTER_ENABLE_LAB=yes
  #     - JUPYTER_NOTEBOOK_DIR=/home/jovyan/work
  #   depends_on:
  #     - spark-master
  #   volumes:
  #     - ./spark-python.ipynb:/home/jovyan/work/spark-python.ipynb

volumes:
  spark-results:
